reps=20000

n=length(y)

mu1=mu2=matrix(0,reps)
mu1[1]=min(y); mu2[1]=max(y)
sig1=sig2=matrix(1,reps)
pr=matrix(.5,reps)

#priors
n01=10; m01=5
n02=10; m02=7

alpha=10; beta=10
a1= 18; b1=34
a2= 18; b2=34

for(i in 2:reps){

#simulate latent classes for each person

denom=pr[i-1]*(dnorm(y,mu1[i-1],sqrt(sig1[i-1]))) +
              (1-pr[i-1])*(dnorm(y,mu2[i-1],sqrt(sig2[i-1])))
lprob=pr[i-1]*(dnorm(y,mu1[i-1],sqrt(sig1[i-1])))/denom
lat=rbinom(length(y),1,lprob)

#simulate class probabilities
pr[i]=rbeta(1,sum(lat==1)+alpha,sum(lat==0)+beta)

#simulate mu1
ybar=0
n1=sum(lat==1,na.rm=T)
if(n1>0){ybar=mean(y[lat==1])}

toobig=1
while(toobig==1){
mu1[i]=rnorm(1,mean=(n01*m01 + n1*ybar)/(n01+n1),
                         sd=sqrt(sig1[i-1]/(n01+n1)) )
if(mu1[i]<mu2[i-1]){toobig=0}
}

#simulate sig1
sh=a1+(1+n1)/2
rt=.5*(2*b1+n01*(mu1[i]-m01)^2+sum((y[lat==1]-mu1[i])^2))
sig1[i]=1/rgamma(1,shape=sh, rate=rt)

#simulate mu2
ybar=0
n2=sum(lat==0,na.rm=T)
if(n2>0){ybar=mean(y[lat==0])}

toosmall=1
while(toosmall==1){
mu2[i]=rnorm(1,mean=(n02*m02 + n2*ybar)/(n02+n2),
                         sd=sqrt(sig2[i-1]/(n02+n2)) )
if(mu2[i]>mu1[i]){toosmall=0}
}

#simulate sig2
sh=a2+(1+n2)/2
rt=.5*(2*b2+n02*(mu2[i]-m02)^2+sum((y[lat==0]-mu2[i])^2))
sig2[i]=1/rgamma(1,shape=sh, rate=rt)

if(i%%100==0){print(c(j,i,mu1[i],mu2[i],sig1[i],sig2[i],pr[i]))}
}